#!/bin/sh
#

#######################
# EXERCICE 1
#######################

# Fonction sujet
#
# On doit d'abord isoler la bonne ligne avec grep et head. Dtecter les '!'
# peut se faire avec expr et des chanes arbitraires entre eux.
# Pour les majuscules, le test quivaut tout simplement a regarder s'il
# existe une seule lettre minuscule
#
function sujet () {
    local ligne=`grep -E "^Subject:" "$1" | head -n1 | sed -r "s/^Subject: //"`
    local r=0

    if expr "$ligne" : '^.*!.*!.*$' >/dev/null; then
	r=1
    elif ! expr "$ligne" : ".*[a-z].*"  >/dev/null; then
	r=1
    fi

    return $r
}


# Fonction from
#
# Comme pour sujet, on s'appuie sur les bracket <> et l'arobase pour extaire
# le nom de domaine. Comme le code d'erreur de nslookup est 0 qu'il trouve
# ou non un nom de domaine, il faut chercher s'il crit "can't find" ou
# non pour conclure.
#
function from () {
    local domain=`grep ^From: "$1" | head -n1 | sed -r "s/^From:[^@]*@([^>]*)>$/\1/"`

    local invalide=`nslookup "$domain" | grep "can't find"`

    test "$invalide" 
    return $((2*(1-$?)))
}


# Fonction mois
#
# Elle ne fait que remplacer le mois, en notation RFC, par son numro dans
# une date. On utilise pour cela une liste de mois, gre manuellement.
#
function mois () {
    local liste="Jan/01:Feb/02:Mar/03:Apr/04:May/05:Jun/06:Jul/07:Aug/08:Sep/09:Oct/10:Nov/11:Dec/12:"
    local arg="$1"

    while [ "$liste" ]; do
	tete=${liste%%:*}
	mois=${tete%/*}
	num=${tete#*/}
	arg=`echo "$arg" | sed "s/$mois/$num/"`
	liste=${liste#*:}
    done

    echo $arg
}


# Fonction pbdate
#
# L'ide ici est d'inverser l'anne et le jour dans la date, puis d'appeler
# la fonction prcdent pour convertir le mois en numrique. Exemple:
# 03 Apr 2008 -> 2008Apr03 -> 20080403
#
# En appliquant  la date de l'emil et  la date courante, on a un test
# suffisant pour savoir s'il y antidatage  au moins un jour.
#
function pbdate () {
    local datemail=`grep ^Date: "$1" | sed -r  "s/^[^0-9]*([^ ]*) ([^ ]*) ([^ ]*).*$/\3\2\1/"`
    local date=`date -R | sed -r  "s/^[^0-9]*([^ ]*) ([^ ]*) ([^ ]*).*$/\3\2\1/"`

    local dm=`mois $datemail`
    local dr=`mois $date`

    echo "dm=$dm, dr=$dr"
    [ $dm -gt $dr ] && return 3
    return 0
}

#######################
# EXERCICE 2
#######################


# Tout ce qui ne commence pas par un '#'
#1)  grep "^[^#]" passwd

# Ide: on va "consommer" tous les champs qui ne nous intressent pas
# en forant la reconnaissance dans sed, mais en ne les remplaant pas
# dans l'expression finale

#2) grep "^[^#]" passwd | sed -r 's/^([^:]*:)([^:]*:){3,3}([^:]*):.*$/\1\3/'

# Ide: on commence d'abord par remplacer par une chane d'espace trop longue
# (les 15 caractres d'un seul coup). Ensuite, on ne retient que les 15
# premiers dans une premire expression, et on force la reconnaissance 
# jusqu'au ':' mais comme prcdemment, on ne replace pas cette partie
# dans la chane substitue. 
#
#3)  grep "^[^#]" passwd | sed -r -e 's/^([^:]*:)([^:]*:){3,3}([^:]*):.*$/\1\3/' -e 's/:/                 :/' -e 's/^(.{15,15})[^:]*:/\1 -> /'
